/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/cli/enumeration/AbstractCliEnumTransformer.java#1 $
 * 
 * Copyright (c) 2008 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.cli.enumeration;

/**
 * Base implementation of CliEnumTransformer.
 * 
 * Subclasses need only implement {@link #cliOptionToEnumValue(Class, String)}.
 * 
 * @author philipc
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public abstract class AbstractCliEnumTransformer implements CliEnumTransformer {

    public <E extends Enum<E>> E cliOptionToEnumValue(Class<E> enumClass, String cliOption) {        
        E[] enumConstants = enumClass.getEnumConstants();
        if (enumConstants != null) {
            for (int i = 0; i < enumConstants.length; i++) {
                
                E enumConstant = enumConstants[i];
                if (enumConstantEquals(enumConstant, cliOption)) {
                    return enumConstant;
                }
            }
        }
        return null;
    }

    /**
     * Returns true if the given cliOption represents the given enumerationValue
     * @param enumerationValue
     * @param cliOption
     * @return true if the given cliOption represents the given enumerationValue
     */
    protected boolean enumConstantEquals(Enum<?> enumerationValue, String cliOption) {
        return enumToCliOption(enumerationValue).equals(cliOption);
    }
}
