/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/cli/enumeration/CliEnumTransformer.java#1 $
 * 
 * Copyright (c) 2008 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.cli.enumeration;

/**
 * Transforms back and forth between an enumeration value and a string cli option.
 * 
 * @author philipc
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public interface CliEnumTransformer {
    
    /**
     * Transforms an enumeration value to a string cli option.
     *  
     * @param enumerationValue the enumeration value to transform
     * @return string cli option 
     */
    String enumToCliOption(Enum<?> enumerationValue);
    
    /**
     * Transforms a string cli option to an enumeration value. 
     *  
     * @param enumClass the enumeration class
     * @param cliOption string cli option 
     * @return the enumeration value to transform
     */
    <E extends Enum<E>> E cliOptionToEnumValue(Class<E> enumClass, String cliOption);

}
