/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/cli/validator/NotNullValidator.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.cli.validator;

import org.apache.commons.cli2.CommandLine;

import com.netapp.common.MsgKey;
import com.netapp.common.cli.binding.ArrayObjectBinding;
import com.netapp.common.cli.binding.BeanObjectBinding;
import com.netapp.common.cli.binding.ObjectBinding;
import com.netapp.common.cli.binding.PrimitiveObjectBinding;
import com.netapp.common.logging.MessageBundle;

/**
 * @author sirianni
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class NotNullValidator implements Validator {

    public void validate(PrimitiveObjectBinding primitiveObjectBinding, CommandLine commandLine) throws ValidationException {
        this.validate((ObjectBinding) primitiveObjectBinding, commandLine);
    }

    public void validate(BeanObjectBinding beanObjectBinding, CommandLine commandLine) throws ValidationException {
        this.validate((ObjectBinding) beanObjectBinding, commandLine);
    }

    public void validate(ArrayObjectBinding collectionObjectBinding, CommandLine commandLine) throws ValidationException {
        this.validate((ObjectBinding) collectionObjectBinding, commandLine);
    }
    
    protected void validate(ObjectBinding objectBinding, CommandLine commandLine) throws ValidationException {
        if (objectBinding.isNull(commandLine)) {
            throw new ValidationException(MessageBundle.localizeMessage(MsgKey.CLI_BASE_REQUIRED_PARAMETER, objectBinding.getOptionDisplay()));
        }        
    }
}
