/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/execution/ShellRunnable.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.execution;

import java.io.File;
import java.io.Serializable;
import java.util.List;

public interface ShellRunnable extends Command, Serializable {

    List<String> getArgumentList();
    
    String getCommandString();
    
    File getWorkingDirectory();
    
    /**
     * Called by {@link ShellCommandTransformer}s with the new argument list (after transformation)
     * generated from the argument list of this ShellRunnable.
     * 
     * This provides a "hook" for ShellRunnable implementations to pass
     * state through the transformation process.
     * 
     * @param argumentList the argument list generated by the transformation
     * @return a new instance of the ShellRunnable class with the given argument list.
     */
    ShellRunnable transformInto(String... argumentList);
}
