/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/OperationLogListener.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow;

import com.netapp.common.logging.LogLevel;
import com.netapp.common.logging.LogListener;
import com.netapp.common.logging.LogMessage;

/**
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class OperationLogListener implements LogListener {
    private PersistenceManager manager;
    private LogLevel minimumLevel = LogLevel.INFO;

    OperationLogListener(PersistenceManager manager) {
        this.manager = manager;
    }
    
    OperationLogListener(PersistenceManager manager, LogLevel minimumLevel) {
        this.manager = manager;
        this.minimumLevel = minimumLevel;
    }
    
    /**
     * @see com.netapp.common.logging.LogListener#append(com.netapp.common.logging.LogMessage)
     */
    public void append(LogMessage log) {
        OperationContext ctx = OperationContext.getThreadContext();
        if (ctx != null 
                && ctx.isManagedBy(this.manager)
                && log.getLevel().compareTo(this.minimumLevel) >= 0) {
            this.manager.addMessage(ctx.getId(), log);
        }
    }

}
