/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/flow/api/OperationService.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.flow.api;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.jws.WebResult;

/**
 * An OperationService is the basic implementation aspects of the web service interface that allow 
 * the functional requests to be managed by the client of the service as asyncronous operations. 
 * Once an operation is successfully created, the methods provided via this interface allow 
 * that operation to be statused or cancelled. Operations of this service are provided allowing 
 * either the client provided or the service generated identifiers.
 * 
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
@WebService (name = "OperationService", targetNamespace = "http://www.netapp.com/smai/Operation")
public interface OperationService {
    /**
     * Cancel the requested operation.
     * 
     * @param id Operation id
     */
    @WebMethod(operationName = "operationCancel", action = "urn:operationCancel")
    void operationCancel(
        @WebParam(name = "operationId") String id);
    
    /**
     * Return the current status of this operation.
     * @param id Operation id
     * @return Operation result indicating current status and any outputs
     */
    @WebMethod(operationName = "operationResult", action = "urn:operationResult")
    @WebResult(name = "result")
    OperationResult operationResult(
        @WebParam(name = "operationId") String id);
        
    @WebMethod(operationName = "operationRelease", action = "urn:operationRelease")
    void operationRelease(
        @WebParam(name = "operationId") String id);
    
    @WebMethod(operationName = "operationResults", action = "urn:operationResults")
    @WebResult(name = "results")
    OperationResult[] operationResults(
        @WebParam(name = "operationIds") String [] ids,
        @WebParam(name = "lastUpdate") OperationUpdateTag lastUpdate);
}
