/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/jaxb/plugin/GWTSerializablePlugin.java#1 $
 *
 * Copyright (c) 2009 NetApp, Inc.
 * All rights reserved. 
 */
package com.netapp.common.jaxb.plugin;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;

// CHECKSTYLE:OFF
import com.sun.codemodel.JClass;
import com.sun.tools.xjc.Options;
import com.sun.tools.xjc.Plugin;
import com.sun.tools.xjc.outline.ClassOutline;
import com.sun.tools.xjc.outline.Outline;
// CHECKSTYLE:ON

/**
 * Mark all generated classes as implementing GWT's serializable
 * marker interface com.google.gwt.user.client.rpc.IsSerializable
 * 
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class GWTSerializablePlugin extends Plugin {

    /**
     * @see com.sun.tools.xjc.Plugin#getOptionName()
     */
    @Override
    public String getOptionName() {
        return "Xgwt-serializable";
    }

    /**
     * @see com.sun.tools.xjc.Plugin#getUsage()
     */
    @Override
    public String getUsage() {
        return "  -Xgwt-serializable :  mark classes with GWT IsSerializable";
    }

    /**
     * @see com.sun.tools.xjc.Plugin#run(com.sun.tools.xjc.outline.Outline, com.sun.tools.xjc.Options, org.xml.sax.ErrorHandler)
     */
    @Override
    public boolean run(Outline model, Options arg1, ErrorHandler arg2) throws SAXException {
        JClass marker = model.getCodeModel().ref("com.google.gwt.user.client.rpc.IsSerializable");
        for (ClassOutline co : model.getClasses()) {
            if (co.implClass.isClass()) {
                co.implClass._implements(marker);
            }
        }
        return true;
    }

}
