/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/platform/FileOwner.java#1 $
 * 
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.platform;

public class FileOwner {
    private User user;
    private Group group;

    /*
     * Invoked from native code - DO NOT REMOVE!!
     */
    public FileOwner() {
        
    }
    
    public FileOwner(User user, Group group) {
        this.user = user;
        this.group = group;
    }
    
    public User getUser() {
        return this.user;
    }

    public void setUser(User user) {
        this.user = user;
    }

    public Group getGroup() {
        return this.group;
    }

    public void setGroup(Group group) {
        this.group = group;
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((this.group == null) ? 0 : this.group.hashCode());
        result = prime * result + ((this.user == null) ? 0 : this.user.hashCode());
        return result;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        
        if (obj == null) {
            return false;
        }
        
        if (!(obj instanceof FileOwner)) {
            return false;
        }
        
        final FileOwner other = (FileOwner) obj;
        
        if (this.group == null) {
            if (other.group != null) {
                return false;
            }
        }
        else if (!this.group.equals(other.group)) {
            return false;
        }
        if (this.user == null) {
            if (other.user != null) {
                return false;
            }
        }
        else if (!this.user.equals(other.user)) {
            return false;
        }
        
        return true;
    }

    @Override
    public String toString() {
        
        return "User: " + this.user + " Group: " + this.group;
    }
}
