/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/platform/windows/WMINativeImpl.java#1 $
 *
 * Copyright (c) 2009 NetApp, Inc.
 * All rights reserved. 
 */
package com.netapp.common.platform.windows;

import java.util.Collection;
import java.util.Map;

/**
 * Native interface to WMI
 * @author sunday
 * @version $Revision: #1 $ $Date: 2010/08/20 $
 */
public class WMINativeImpl extends WMIConnection {
    static {
        System.loadLibrary("com_netapp_common_platform_windows_WMINativeImpl");
    }
    
    protected WMINativeImpl(String namespace) {
        super(namespace);
    }
    
    /**
     * Execute a WQL query and marshall the results back into map.
     * @param query WQL query to execute
     * @return Collection of WMI objects
     */
    public native Collection<Map<String, Object>> query(String query);

    /**
     * Get a WMI object by path
     * @return Map for the specified object
     */
    public native Map<String, Object> getObject(String path);
    
    /**
     * Execute a method on an object and marshall the results back into
     * a map.
     * @param path
     * @param method
     * @param inParams
     * @return Result of method call
     */
    public native Map<String, Object> execMethod(String path, String method, Map<String, Object> inParams);
}
