/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/text/MapSubstitutionPatternContext.java#1 $
 *
 * Copyright (c) 2007 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.text;

import java.util.Map;

public class MapSubstitutionPatternContext implements SubstitutionPatternContext {
    
    private final Map<String, String> variableValues;
    private final String defaultValue;

    public MapSubstitutionPatternContext(Map<String, String> variableValues) {
        this(variableValues, null);
    }

    /**
     * @param variableValues values of variables keyed by variable name
     * @param defaultValue returned if value in the map is null
     */
    public MapSubstitutionPatternContext(Map<String, String> variableValues, String defaultValue) {
        this.variableValues = variableValues;
        this.defaultValue = defaultValue;
        
    }

    public String getValue(String variableName) {
        String value = this.variableValues.get(variableName);
        if (value == null) {
            value = this.defaultValue;
        }
        return value;
    }

}
