/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/generator/GeneratorUtils.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.generator;

import java.util.List;
import java.util.Properties;

import org.apache.commons.lang.WordUtils;

import com.netapp.common.util.StringUtils;

public class GeneratorUtils {
    
    private GeneratorUtils() {
        
    }
    
    public static String zapiToUpperCamelCase(String s) {
        if (s == null) {
            return null;
        }
        
        return WordUtils.capitalizeFully(s, new char[] {'-', ' ', '_'}).replaceAll("[_ -]", "");
    }
    
    public static String zapiToLowerCamelCase(String s) {
        if (s == null) {
            return null;
        }
        
        return StringUtils.initialLowerCase(zapiToUpperCamelCase(s));
    }
    
    public static String removeDashes(String s) {
        if (s == null) {
            return null;
        }
        
        return s.replaceAll("-", "");
    }
    
    /**
     * Parses property arguments in the form of '-Pkey=value' and returns a <code>Properties</code> instance.
     * 
     * @param propertyArgs the property arguments
     * @return a <code>Properties</code> instance
     */
    public static Properties parsePropertyArgs(List<String> propertyArgs) {
        Properties generationProperties = new Properties();
        for (String property : propertyArgs) {
            String pairString = property.substring(property.indexOf('P') + 1,
                    property.length());
            String[] pairSplit = pairString.split("=");
            if (pairSplit.length != 2) {
                throw new IllegalArgumentException(property);
            }

            String value = pairSplit[1].replaceAll("\"", "");

            if (value.trim().isEmpty()) {
                throw new IllegalArgumentException(
                        "Property value is missing: " + property);
            }
            generationProperties.put(pairSplit[0], value);
        }
        return generationProperties;
    }

}
