/*
 * $Id: //depot/prod/newport_news/Radamant.1/src/java/com/netapp/common/zapi/generator/autozapi/AutoZapiTypedefFieldGenerator.java#1 $
 * 
 * Copyright (c) 2009 Network Appliance, Inc.
 * All rights reserved.
 */
package com.netapp.common.zapi.generator.autozapi;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import com.netapp.common.zapi.parser.Typedef.TypedefField;

public class AutoZapiTypedefFieldGenerator extends AutoZapiFieldGenerator<TypedefField> {
    
    public AutoZapiTypedefFieldGenerator(AutoZapiGeneratorFactory generatorFactory, TypedefField typedefField) {
        super(generatorFactory, typedefField);
    }

    @Override
    public Set<String> getImports() {
        Set<String> imports = super.getImports();
        imports.add(AutoZapiTypeGenerator.ANNOTATION_PACKAGE + ".Element");
        return imports;
    }
    
    @Override
    public List<String> getFieldAnnotations() {
        // We want the Element annotation first in the list
        // followed by any generic field annotations
        List<String> list = new ArrayList<String>();
        list.add("Element(\"" + getTarget().getName() + "\")");
        list.addAll(super.getFieldAnnotations());
        return list;
    }
    
}
